config/routes.rb
Twitter::Application.routes.draw do
  resources :tweets do
    member do
      post :retweet
    end
  end
    
  resources :profiles do 
    member do 
      post :follow  
    end
  end

   devise_for :users
   root :to => 'tweets#index'

end

app/models/following.rb
class Following < ActiveRecord::Base
  attr_accessible :from_id, :to_id
end

app/models/retweet.rb
class Retweet < ActiveRecord::Base
  attr_accessible :tweet_id, :user_id
end

app/models/tweet.rb
class Tweet < ActiveRecord::Base
  attr_accessible :autor_id, :tweet, :parent_id
  belongs_to :author, class_name: "User", foreign_key: "autor_id"
 
  def already_retweeted? current_user
    Retweet.where(tweet_id: self.id, user_id: current_user.id).count > 0
  end
end   

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :token_authenticatable, :confirmable,
  # :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  # Setup accessible (or protected) attributes for your model
  attr_accessible :email, :password, :password_confirmation, :remember_me, :name
  # attr_accessible :title, :body
  has_many :tweets, foreign_key: "autor_id"
  validates :name, :presence => true
    
  def already_follow? profile
    Following.where(from_id: self.id, to_id: profile.id).count > 0 
  end

  def authorized_tweets
    ids = []
    ids << self.id
    ids << Following.where(from_id: self.id).map{ |f| f.to_id }
    retweets = Retweet.where(user_id: ids)#.limit(10).order("created_at DESC")
    Tweet.where('autor_id in (?) OR id in (?)', ids.flatten, retweets.map(&:tweet_id)).order("created_at DESC")
  end

  def profile_tweets
    ids = []
    ids << self.id
    retweets = Retweet.where(user_id: ids)#.limit(10).order("created_at DESC")
    tweets = Tweet.where('autor_id in (?) OR id in (?)', ids.flatten, retweets.map(&:tweet_id)).order("created_at DESC")
  end
  
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery
  before_filter :authenticate_user!
end

app/controllers/profiles_controller.rb
class ProfilesController < ApplicationController
  def show
    @profile = User.find(params[:id])
    @tweets = @profile.profile_tweets 
    @following = Following.where(from_id: @profile.id)
  end

  def index
    @profiles = User.all
  end


  def follow
    @profile = User.find(params[:id])
    if current_user == @profile
      redirect_to profile_path(@profile)
      return
    end
    if current_user.already_follow? @profile
      redirect_to profile_path(@profile)
      return
    end
    @following = Following.new
    @following.from_id = current_user.id
    @following.to_id = @profile.id
    @following.save
    redirect_to profile_path(@profile)
  end
end 

app/controllers/tweets_controller.rb
class TweetsController < ApplicationController
  # GET /tweets
  # GET /tweets.json
  def index
    @tweets = current_user.authorized_tweets.page(params[:page]).per(10)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @tweets }
    end
  end

  # GET /tweets/1
  # GET /tweets/1.json
  def show
    @tweet = Tweet.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @tweet }
    end
  end

  # GET /tweets/new
  # GET /tweets/new.json
  def new
    @tweet = Tweet.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @tweet }
    end
  end

  # GET /tweets/1/edit
  def edit
    @tweet = Tweet.find(params[:id])
  end

  # POST /tweets
  # POST /tweets.json
  def create
    @tweet = Tweet.new(params[:tweet])
    @tweet.autor_id = current_user.id


    respond_to do |format|
      if @tweet.save
        format.html { redirect_to root_path, notice: 'Tweet was successfully created.' }
        format.json { render json: @tweet, status: :created, location: @tweet }
        format.js
      else
        format.html { render action: "new" }
        format.json { render json: @tweet.errors, status: :unprocessable_entity }
        format.js
      end
    end
  end

  # PUT /tweets/1
  # PUT /tweets/1.json
  def update
    @tweet = Tweet.find(params[:id])

    respond_to do |format|
      if @tweet.update_attributes(params[:tweet])
        format.html { redirect_to @tweet, notice: 'Tweet was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @tweet.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tweets/1
  # DELETE /tweets/1.json
  def destroy
    @tweet = Tweet.find(params[:id])
    @tweet.destroy

    respond_to do |format|
      format.html { redirect_to tweets_url }
      format.json { head :no_content }
    end
  end
 
  def retweet
    @tweet = Tweet.find(params[:id])
    @retweet = Retweet.new
    @retweet.tweet_id = @tweet.id
    @retweet.user_id = current_user.id 
    @retweet.save 
    redirect_to root_path
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/tweets_helper.rb
module TweetsHelper
end

app/views/layouts/_nav.html.erb
<div class="navbar navbar-static-top">
  <div class="navbar-inner">
    <div class="container-fluid">
      <a class="brand" href="#">Tweets</a>
      <ul class="nav">
        <li><%= link_to "Timeline", tweets_path %></li>
        <li><%= link_to "Me", profile_path(current_user.id) %></li>
        <li><%= link_to 'People', profiles_path %></li>
      </ul>
      <ul class="nav pull-right">
        <% if current_user %>
          <li> <%= link_to "Account", edit_user_registration_path %></li>
          <li><%= link_to "Log Out", destroy_user_session_path, :method => 'delete' %></li>
        <% else %>
          <li><%= link_to "Sign In / Sign Up", new_user_session_path %></li>
        <% end %>
      </ul>
    </div>
  </div>
</div>
</div>
<br/>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Twitter</title>
    <%= stylesheet_link_tag    "application", :media => "all" %>
    <%= javascript_include_tag "application" %>
    <%= csrf_meta_tags %>
  </head>
  <body>
    <%= render "layouts/nav" %>
    <div class="content">
      <div class="container-fluid">
        <div class="row-fluid">
          <div class="span5">
            <div class="well">
              <%= render "tweets/form", tweet: Tweet.new %>
            </div>
          </div>
          <div class="span7"><%= yield %></div> 
        </div>
      </div>
    </body>
  </html>

app/views/layouts/devise.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Twitter</title>
    <%= stylesheet_link_tag    "application", :media => "all" %>
    <%= javascript_include_tag "application" %>
    <%= csrf_meta_tags %>
  </head>
  <body>
    <div class="content">
      <div class="container">
        <%= yield %>
      </div>
    </body>
  </html>

app/views/profiles/index.html.erb
<% @profiles.each do |profile| %>
  <div class="well">
    <%= link_to profile.name, profile_path(profile) %>
  </div>
  <% end %>

app/views/profiles/show.html.erb
<p>
  <h1> <%= @profile.name %> </h1>
  <% if current_user != @profile && !current_user.already_follow?(@profile) %>
    <%= link_to "Follow", follow_profile_path(@profile), class: "btn btn-primary", method: "post" %>
  <% end %>
</p>
<h4> Following <h4>

    <h5>      
      <%= @following.map { |follow| link_to(User.find(follow.to_id).name, profile_path) }.join(", ").html_safe %>         
    </h5>
<h3> Recent tweets </h3>
<% @tweets.each do |tweet| %>
  <div class="well">
    <h4> <%= tweet.tweet %> </h4>
    <div>
      <% if !tweet.already_retweeted?(current_user) %>
        <%= link_to "Retweet", retweet_tweet_path(tweet), method: "post", :class => "pull-right" %>
      <% end %>
      <%= link_to tweet.author.name, profile_path(tweet.author) %>
      <%= link_to time_ago_in_words(tweet.created_at), tweet_path(tweet) %>
      ago
      <%= link_to "Reply", tweet %>
    </div>  
  </div>
<% end %>

app/views/tweets/_form.html.erb
<%= form_for(tweet, :remote => true) do |f|  %>
  <% if tweet.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(tweet.errors.count, "error") %> prohibited this tweet from being saved:</h2>

      <ul>
      <% tweet.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  
  <%= f.hidden_field :parent_id %><br />

  <div class="field">
    <%= f.label :tweet %><br />
    <%= f.text_field :tweet %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/tweets/_tweet.html.erb
<div class="well">
  <h4> <%= tweet.tweet %> </h4>
  <div>
    <% if !tweet.already_retweeted?(current_user) %>
      <%= link_to "Retweet", retweet_tweet_path(tweet), method: "post", :class => "pull-right" %>
    <% end %>
    <%= link_to tweet.author.name, profile_path(tweet.author) %>
    <%= link_to time_ago_in_words(tweet.created_at), tweet_path(tweet) %>
    ago
    <%= link_to "Reply", tweet %>
  </div>  
</div>

app/views/tweets/create.js.erb
$(".timeline").prepend("<%= escape_javascript(render(@tweet))%>");
$(".new_tweet").append("saved");

app/views/tweets/edit.html.erb
<h1>Editing tweet</h1>

<%= render 'form' %>

<%= link_to 'Show', @tweet %> |
<%= link_to 'Back', tweets_path %>

app/views/tweets/index.html.erb
<div class = "timeline">
<%= render @tweets %> 
</div>

<%= paginate @tweets %>

app/views/tweets/new.html.erb
<h1>New tweet</h1>

<%= render 'form' %>

<%= link_to 'Back', tweets_path %>

app/views/tweets/show.html.erb
<p id="notice"><%= notice %></p>

  <div class="well">
    <h4> <%= @tweet.tweet %> </h4>
    <div>
      <% if !@tweet.already_retweeted?(current_user) %>
        <%= link_to "Retweet", retweet_tweet_path(@tweet), method: "post", :class => "pull-right" %>
      <% end %>
      <%= link_to @tweet.author.name, profile_path(@tweet.author) %>
      <%= link_to time_ago_in_words @tweet.created_at, tweet_path(@tweet) %>
      ago
    </div>
    <%= render "tweets/form", tweet: Tweet.new(parent_id: @tweet.id) %>
  </div>